require "mkmf"

def have_librarys(*lib)
  printf "checking librarys lib%s... ", lib.join(", lib")
  STDOUT.flush

  libs = "-l" + lib.join(" -l") + " " + $libs
  r = try_link(<<"SRC", libs)
int main() { return 0; }
SRC
  unless r
    print "no\n"
    return false
  end

  $libs = libs
  print "yes\n"
  return true
end

case RUBY_PLATFORM
when "i386-linux"
  dir_config("--with-elf","/usr/include","/usr/lib")
  if ! have_library("elf") then
    STDERR.print "cannot find library file for elf\n"
    STDERR.print "ruby extconf.rb --with-elf-lib=(path of libelf.a)\n"
    exit 1
  end

  dir_config("--with-ffc","/usr/include","/usr/FFC/lib")
  if ! have_librarys("fj9f6","fj9i6") then
    STDERR.print "cannot find library file for fj9f6,fj9i6\n"
    STDERR.print "ruby extconf.rb --with-ffc-lib=(path of libfj9{r,i}6.so)\n"
    exit 1
  end

when "sparc-solaris2.5.1"
  dir_config("--with-sun","/usr/include","/opt/SUNWspro/lib")
  if ! have_librarys("F77","sunmath") then
    STDERR.print "cannot find library file for F77,sunmath\n"
    STDERR.print "ruby extconf.rb --with-sun-lib=(path of libF77.so,libsunmath.so)\n"
    exit 1
  end

end

dir_config("--with-ssl2","/usr/include","/usr/FFC/lib")
if ! have_library("ssl2") then
  STDERR.print "cannot find library file for ssl2\n"
  STDERR.print "ruby extconf.rb --with-ssl2-lib=(path of libssl2.a)\n"
  exit 1
end

dir_config("--with-narray",Config::CONFIG["archdir"])
if ! have_header("narray.h") then
  STDERR.print "cannot find header file for narray\n"
  STDERR.print "ruby extconf.rb --with-narray-include=(path of narray.h)\n"
end


create_makefile("ssl2")
