#include <ruby.h>
#include <math.h>
#include <stdio.h>
#include <narray.h>
#include "ssl2.h"

extern void aklag_(float*,float*,int*,float*,int*,float*,float*,float*,int*);
extern void akher_(float*,float*,float*,int*,float*,int*,float*,float*,float*,int*);
extern void splv_(float*,float*,int*,int*,float*,float*,int*,float*,int*,float*,int*);
extern void bif1_(float*,int*,int*,float*,int*,float*,int*,float*,float*,int*);
extern void bif2_(float*,int*,int*,float*,int*,float*,int*,float*,float*,int*);
extern void bif3_(float*,int*,int*,float*,float*,int*,float*,int*,float*,float*,int*);
extern void bif4_(float*,int*,int*,float*,int*,float*,int*,float*,float*,int*);
extern void bifd1_(float*,int*,float*,int*,int*,float*,int*,int*,float*,int*,int*,float*,int*,float*,float*,int*);
extern void bifd3_(float*,int*,float*,int*,int*,float*,int*,float*,int*,float*,int*,int*,float*,int*,float*,float*,int*);
extern void akmid_(float*,int*,float*,int*,float*,int*,int*,float*,int*,float*,int*,float*,float*,int*);
extern void inspl(float*,float*,float*,int*,float*,float*,float*,int*);
extern void akmin(float*,float*,int*,float*,float*,float*,int*);
extern void bic1_(float*,float*,float*,int*,int*,float*,float*,int*);
extern void bic2_(float*,float*,float*,int*,int*,float*,float*,int*);
extern void bic3_(float*,float*,int*,int*,float*,float*,float*,int*);
extern void bic4_(float*,float*,int*,int*,float*,float*,int*);
extern void bicd1_(float*,int*,float*,int*,float*,int*,int*,float*,float*,int*);
extern void bicd3_(float*,int*,float*,int*,float*,int*,int*,float*,float*,float*,int*);


static VALUE
rb_aklag(self, x, y, v, m, eps)
     VALUE self, x, y, v, m, eps;
{
  float *cx;
  float *cy;
  int n;
  float cv;
  int cm;
  float ceps;
  float f;
  float *vw;
  int icon;

  int nn;

  cm = NUM2INT(m);
  cv = (float)NUM2DBL(v);
  ceps = (float)NUM2DBL(eps);

  cx = ssl2_getcary(x,&n);

  cy = ssl2_getcary(y,&nn);
  if ( n!=nn )
    rb_raise(rb_eRuntimeError, "y.length must be = x.length");

  if ( cm>n )
    rb_raise(rb_eRuntimeError, "m must be <= n");

  vw = ALLOC_N(float,4*n);

  aklag_(cx,cy,&n,&cv,&cm,&ceps,&f,vw,&icon);
  free(vw);
  free(cx);
  free(cy);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(3,rb_float_new((double)f),INT2NUM(cm),rb_float_new((double)ceps));
}


static VALUE
rb_akher(self, x, y, dy, v, m, eps)
     VALUE self, x, y, dy, v, m, eps;
{
  float *cx;
  float *cy;
  float *cdy;
  int n;
  float cv;
  int cm;
  float ceps;
  float f;
  float *vw;
  int icon;

  int nn;

  cm = NUM2INT(m);
  cv = (float)NUM2DBL(v);
  ceps = (float)NUM2DBL(eps);

  cx = ssl2_getcary(x,&n);

  cy = ssl2_getcary(y,&nn);
  if ( n!=nn )
    rb_raise(rb_eRuntimeError, "y.length must be = x.length");

  cdy = ssl2_getcary(dy,&nn);
  if ( n!=nn )
    rb_raise(rb_eRuntimeError, "dy.length must be = x.length");

  if ( cm>n )
    rb_raise(rb_eRuntimeError, "m must be <= n");

  vw = ALLOC_N(float,5*n);

  akher_(cx,cy,cdy,&n,&cv,&cm,&ceps,&f,vw,&icon);
  free(vw);
  free(cx);
  free(cy);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(3,rb_float_new((double)f),INT2NUM(cm),rb_float_new((double)ceps));
}


static VALUE
rb_splv(self, x, y, isw, dy, v)
     VALUE self, x, y, isw, dy, v;
{
  float *cx;
  float *cy;
  int n;
  int *cisw;
  float *cdy;
  float *cv;
  int m;
  float *dv;
  float *vw;
  int icon;

  VALUE ndv;
  int *shape;
  int nn;

  cx = ssl2_getcary(x,&n);
  if ( n<3 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 3");

  cy = ssl2_getcary(y,&nn);
  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be = x.length");

  cisw = ssl2_getcaryi(isw,&nn);
  if ( nn!=2 )
    rb_raise(rb_eRuntimeError, "isw.length must be = 2");
  if ( cisw[0]<1 || 4<cisw[0] )
    rb_raise(rb_eRuntimeError, "isw[0] must be 1, 2, 3 or 4");
  if ( cisw[1]<1 || 4<cisw[1] )
    rb_raise(rb_eRuntimeError, "isw[1] must be 1, 2, 3 or 4");

  cdy = ssl2_getcary(dy,&nn);
  if ( nn!=2 )
    rb_raise(rb_eRuntimeError, "dy.length must be = 2");

  cv = ssl2_getcary(v,&m);

  dv = ALLOC_N(float,m*3);
  vw = ALLOC_N(float,2*n);

  splv_(cx,cy,&n,cisw,cdy,cv,&m,dv,&m,vw,&icon);
  free(vw);
  free(cx);
  free(cy);
  free(cisw);
  free(cdy);
  free(cv);

  shape = ALLOC_N(int,2);
  shape[0] = m;
  shape[1] = 3;
  ndv = ssl2_getary(dv,2,shape);
  free(shape);
  free(dv);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return ndv;
}


static VALUE
rb_bif1(self, x, c, v, m, isw)
     VALUE self, x, c, v, m, isw;
{
  float *cx;
  int n;
  int cm;
  float *cc;
  int cisw;
  float cv;
  int i;
  float f;
  float *vw;
  int icon;

  int ic;

  cv = (float)NUM2DBL(v);
  cisw = NUM2INT(isw);
  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);
  if ( n<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 2");

  cc = ssl2_getcary(c,&ic);
  if ( ic!=n+cm-1 )
    rb_raise(rb_eRuntimeError, "c.length must be n+m-1");

  if ( TYPE(isw)!=T_FIXNUM )
    rb_raise(rb_eTypeError, "isw is invalid type");

  if ( cisw>cm )
    rb_raise(rb_eRuntimeError, "isw must be < m");
  else if ( cisw<-1 )
    rb_raise(rb_eRuntimeError, "isw must be >= -1");

  if ( cv<cx[0] )
    rb_raise(rb_eRuntimeError, "v must be >= x[0]");
  else if ( cv>cx[n-1] )
    rb_raise(rb_eRuntimeError, "v must be <= x[-1]");

  for ( i=0; i<n; i++ ){
    if ( cv<cx[i] ) break;
  }

  vw = ALLOC_N(float,cm+1);

  bif1_(cx,&n,&cm,cc,&cisw,&cv,&i,&f,vw,&icon);
  free(vw);
  free(cx);
  free(cc);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_float_new((double)f);
}


static VALUE
rb_bif2(self, x, c, v, m, isw)
     VALUE self, x, c, v, m, isw;
{
  float *cx;
  int n;
  int cm;
  float *cc;
  int cisw;
  float cv;
  int i;
  float f;
  float *vw;
  int icon;

  int ic;

  cv = (float)NUM2DBL(v);
  cisw = NUM2INT(isw);
  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);
  if ( n<(cm+1)/2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= (m+1)/2");

  cc = ssl2_getcary(c,&ic);
  if ( ic!=n+cm-1 )
    rb_raise(rb_eRuntimeError, "c.length must be n+m-1");

  if ( TYPE(isw)!=T_FIXNUM )
    rb_raise(rb_eTypeError, "isw is invalid type");

  if ( cisw>cm )
    rb_raise(rb_eRuntimeError, "isw must be < m");
  else if ( cisw<-1 )
    rb_raise(rb_eRuntimeError, "isw must be >= -1");

  if ( cv<cx[0] )
    rb_raise(rb_eRuntimeError, "v must be >= x[0]");
  else if ( cv>cx[n-1] )
    rb_raise(rb_eRuntimeError, "v must be <= x[-1]");

  for ( i=0; i<n; i++ ){
    if ( cv<cx[i] ) break;
  }

  vw = ALLOC_N(float,cm+1);

  bif2_(cx,&n,&cm,cc,&cisw,&cv,&i,&f,vw,&icon);
  free(vw);
  free(cx);
  free(cc);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_float_new((double)f);
}


static VALUE
rb_bif3(self, x, c, xt, v, m, isw)
     VALUE self, x, c, xt, v, m, isw;
{
  float *cx;
  int n;
  int cm;
  float *cc;
  float *cxt;
  int cisw;
  float cv;
  int i;
  float f;
  float *vw;
  int icon;

  int ic;

  cv = (float)NUM2DBL(v);
  cisw = NUM2INT(isw);
  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);
  if ( n<cm+2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= m+2");

  cc = ssl2_getcary(c,&ic);
  if ( ic!=n )
    rb_raise(rb_eRuntimeError, "c.length must be n");

  cxt = ssl2_getcary(xt,&ic);
  if ( ic!=n-cm+1 )
    rb_raise(rb_eRuntimeError, "xt.length must be c-m+1");

  if ( TYPE(isw)!=T_FIXNUM )
    rb_raise(rb_eTypeError, "isw is invalid type");

  if ( cisw>cm )
    rb_raise(rb_eRuntimeError, "isw must be < m");
  else if ( cisw<-1 )
    rb_raise(rb_eRuntimeError, "isw must be >= -1");

  if ( cv<cx[0] )
    rb_raise(rb_eRuntimeError, "v must be >= x[0]");
  else if ( cv>cx[n-1] )
    rb_raise(rb_eRuntimeError, "v must be <= x[-1]");

  for ( i=0; i<n; i++ ){
    if ( cv<cx[i] ) break;
  }

  vw = ALLOC_N(float,2*cm+2);

  bif3_(cx,&n,&cm,cc,cxt,&cisw,&cv,&i,&f,vw,&icon);
  free(vw);
  free(cx);
  free(cc);
  free(cxt);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_float_new((double)f);
}


static VALUE
rb_bif4(self, x, c, v, m, isw)
     VALUE self, x, c, v, m, isw;
{
  float *cx;
  int n;
  int cm;
  float *cc;
  int cisw;
  float cv;
  int i;
  float f;
  float *vw;
  int icon;

  int ic;

  cv = (float)NUM2DBL(v);
  cisw = NUM2INT(isw);
  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);
  if ( n<cm+2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= m+2");

  cc = ssl2_getcary(c,&ic);
  if ( ic!=n+cm-1 )
    rb_raise(rb_eRuntimeError, "c.length must be n+m-1");

  if ( TYPE(isw)!=T_FIXNUM )
    rb_raise(rb_eTypeError, "isw is invalid type");

  if ( cisw>cm )
    rb_raise(rb_eRuntimeError, "isw must be < m");
  else if ( cisw<-1 )
    rb_raise(rb_eRuntimeError, "isw must be >= -1");

  if ( cv<cx[0] )
    rb_raise(rb_eRuntimeError, "v must be >= x[0]");
  else if ( cv>cx[n-1] )
    rb_raise(rb_eRuntimeError, "v must be <= x[-1]");

  for ( i=0; i<n; i++ ){
    if ( cv<cx[i] ) break;
  }

  vw = ALLOC_N(float,cm+1);

  bif4_(cx,&n,&cm,cc,&cisw,&cv,&i,&f,vw,&icon);
  free(vw);
  free(cx);
  free(cc);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_float_new((double)f);
}


static VALUE
rb_bifd1(self, x, y, c, vx, vy, m, iswx, iswy)
     VALUE self, x, y, c, vx, vy, m, iswx, iswy;
{
  float *cx;
  int nx;
  float *cy;
  int ny;
  int cm;
  float *cc;
  int k;
  int ciswx;
  float cvx;
  int ix;
  int ciswy;
  float cvy;
  int iy;
  float f;
  float *vw;
  int icon;

  int nn;

  cx = ssl2_getcary(x,&nx);
  if ( nx<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >=2");

  cy = ssl2_getcary(y,&ny);
  if ( ny<2 )
    rb_raise(rb_eRuntimeError, "y.length must be >=2");

  cm = NUM2INT(m);
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");
  if ( (cm/2)*2==cm )
    rb_raise(rb_eRuntimeError, "m must be even");

  cc = ssl2_getcary(c,&nn);
  k = nn/(ny+cm-1);
  if ( nn!=(nx+cm-1)*(ny+cm-1) )
    rb_raise(rb_eRuntimeError, "c.length must be (nx+m-1)*(ny+m-1)");

  ciswx = NUM2INT(iswx);
  if ( ciswx<-1 )
    rb_raise(rb_eRuntimeError, "iswx must be >= -1");
  if ( ciswx>cm )
    rb_raise(rb_eRuntimeError, "iswx must be <= m");

  cvx = (float) NUM2DBL(vx);
  if ( cvx < cx[0] )
    rb_raise(rb_eRuntimeError, "vx must be >= x[0]");
  if ( cvx > cx[nx-1] )
    rb_raise(rb_eRuntimeError, "vx must be <= x[-1]");

  for ( ix=0; ix<nx; ix++ ){
    if ( cvx<cx[ix] ) break;
  }

  ciswy = NUM2INT(iswy);
  if ( ciswy<-1 )
    rb_raise(rb_eRuntimeError, "iswy must be >= -1");
  if ( ciswy>cm )
    rb_raise(rb_eRuntimeError, "iswy must be <= m");

  cvy = (float) NUM2DBL(vy);
  if ( cvy < cy[0] )
    rb_raise(rb_eRuntimeError, "vy must be >= y[0]");
  if ( cvy > cy[ny-1] )
    rb_raise(rb_eRuntimeError, "vy must be <= y[-1]");

  for ( iy=0; iy<ny; iy++ ){
    if ( cvy<cy[iy] ) break;
  }

  vw = ALLOC_N(float,4*(cm+1)+MAX(nx,ny)+cm-1);

  bifd1_(cx,&nx,cy,&ny,&cm,cc,&k,&ciswx,&cvx,&ix,&ciswy,&cvy,&iy,&f,vw,&icon);
  free(cx);
  free(cy);
  free(cc);
  free(vw);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_float_new((double)f);
}


static VALUE
rb_bifd3(self, x, y, c, xt, vx, vy, m, iswx, iswy)
     VALUE self, x, y, c, xt, vx, vy, m, iswx, iswy;
{
  float *cx;
  int nx;
  float *cy;
  int ny;
  int cm;
  float *cc;
  float *cxt;
  int ciswx;
  float cvx;
  int ix;
  int ciswy;
  float cvy;
  int iy;
  float f;
  float *vw;
  int icon;

  int nn;

  cx = ssl2_getcary(x,&nx);
  if ( nx<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >=2");

  cy = ssl2_getcary(y,&ny);
  if ( ny<2 )
    rb_raise(rb_eRuntimeError, "y.length must be >=2");

  cm = NUM2INT(m);
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");
  if ( (cm/2)*2==cm )
    rb_raise(rb_eRuntimeError, "m must be even");

  cc = ssl2_getcary(c,&nn);
  if ( nn!=nx*ny )
    rb_raise(rb_eRuntimeError, "c.length must be nx*ny");

  cxt = ssl2_getcary(xt,&nn);
  if ( nn!=(nx+cm-1)*(ny+cm-1) )
    rb_raise(rb_eRuntimeError, "xt.length must be (nx+m-1)*(ny+m-1)");

  ciswx = NUM2INT(iswx);
  if ( ciswx<-1 )
    rb_raise(rb_eRuntimeError, "iswx must be >= -1");
  if ( ciswx>cm )
    rb_raise(rb_eRuntimeError, "iswx must be <= m");

  cvx = (float) NUM2DBL(vx);
  if ( cvx < cx[0] )
    rb_raise(rb_eRuntimeError, "vx must be >= x[0]");
  if ( cvx > cx[nx-1] )
    rb_raise(rb_eRuntimeError, "vx must be <= x[-1]");

  for ( ix=0; ix<nx; ix++ ){
    if ( cvx<cx[ix] ) break;
  }

  ciswy = NUM2INT(iswy);
  if ( ciswy<-1 )
    rb_raise(rb_eRuntimeError, "iswy must be >= -1");
  if ( ciswy>cm )
    rb_raise(rb_eRuntimeError, "iswy must be <= m");

  cvy = (float) NUM2DBL(vy);
  if ( cvy < cy[0] )
    rb_raise(rb_eRuntimeError, "vy must be >= y[0]");
  if ( cvy > cy[ny-1] )
    rb_raise(rb_eRuntimeError, "vy must be <= y[-1]");

  for ( iy=0; iy<ny; iy++ ){
    if ( cvy<cy[iy] ) break;
  }

  vw = ALLOC_N(float,4*(cm+1)+MAX(nx,ny));

  bifd3_(cx,&nx,cy,&ny,&cm,cc,&nx,cxt,&ciswx,&cvx,&ix,&ciswy,&cvy,&iy,&f,vw,&icon);
  free(cx);
  free(cy);
  free(cc);
  free(cxt);
  free(vw);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_float_new((double)f);
}


static VALUE
rb_akmid(self, x, y, fxy, vx, vy, vw, isw)
     VALUE self, x, y, fxy, vx, vy, vw, isw;
{
  float *cx;
  int nx;
  float *cy;
  int ny;
  float *cfxy;
  int cisw;
  float cvx;
  int ix;
  float cvy;
  int iy;
  float f;
  float *cvw;
  int icon;

  VALUE nvw;
  int shape[1];

  int nn;

  cx = ssl2_getcary(x,&nx);
  if ( nx<3 )
    rb_raise(rb_eRuntimeError, "nx must be >=3 ");

  cy = ssl2_getcary(y,&ny);
  if ( ny<3 )
    rb_raise(rb_eRuntimeError, "ny must be >=3 ");

  cfxy = ssl2_getcary(fxy,&nn);
  if ( nn!=nx*ny )
    rb_raise(rb_eRuntimeError, "fxy.length must be nx*ny");

  cisw = NUM2INT(isw);

  cvx = (float) NUM2DBL(vx);
  if ( cvx<cx[0] )
    rb_raise(rb_eRuntimeError, "vx must be >= x[0]");
  if ( cvx>cx[nx-1] )
    rb_raise(rb_eRuntimeError, "vx must be <= x[-1]");

  for ( ix=0; ix<nx; ix++ ){
    if ( cvx<cx[ix] ) break;
  }

  cvy = (float) NUM2DBL(vy);
  if ( cvy<cy[0] )
    rb_raise(rb_eRuntimeError, "vy must be >= y[0]");
  if ( cvy>cy[ny-1] )
    rb_raise(rb_eRuntimeError, "vy must be <= y[-1]");

  for ( iy=0; iy<ny; iy++ ){
    if ( cvy<cy[iy] ) break;
  }

  cvw = ssl2_getcary(vw,&nn);
  if ( nn!=50 )
    rb_raise(rb_eRuntimeError, "vw.length must be 50");


  akmid_(cx,&nx,cy,&ny,cfxy,&nx,&cisw,&cvx,&ix,&cvy,&iy,&f,cvw,&icon);
  free(cx);
  free(cy);
  free(cfxy);

  shape[0] = 50;
  nvw = ssl2_getary(cvw,1,shape);
  free(cvw);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(2,rb_float_new((double)f),nvw);
}


static VALUE
rb_inspl(self, x, y, dy)
     VALUE self, x, y, dy;
{
  float *cx;
  float *cy;
  float *cdy;
  int n;
  float *c;
  float *d;
  float *e;
  int icon;

  VALUE nc, nd, ne;
  int shape[1];

  int nn;

  cx = ssl2_getcary(x,&n);
  if ( n<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 2");

  cy = ssl2_getcary(y,&nn);
  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be x.length");

  cdy = ssl2_getcary(dy,&nn);
  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "dy.length must be x.length");


  c = ALLOC_N(float,n);
  d = ALLOC_N(float,n);
  e = ALLOC_N(float,n);
  inspl_(cx,cy,cdy,&n,c,d,e,&icon);
  free(cx);
  free(cy);
  free(cdy);

  shape[0]=n;
  nc = ssl2_getary(c,1,shape);
  nd = ssl2_getary(d,1,shape);
  ne = ssl2_getary(e,1,shape);
  free(c);
  free(d);
  free(e);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(3,nc,nd,ne);
}


static VALUE
rb_akmin(self, x, y)
     VALUE self, x, y;
{
  float *cx;
  float *cy;
  int n;
  float *c;
  float *d;
  float *e;
  int icon;

  VALUE nc, nd, ne;
  int shape[1];

  int nn;

  cx = ssl2_getcary(x,&n);
  if ( n<3 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 3");

  cy = ssl2_getcary(y,&nn);
  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be x.length");


  c = ALLOC_N(float,n-1);
  d = ALLOC_N(float,n-1);
  e = ALLOC_N(float,n-1);
  akmin_(cx,cy,&n,c,d,e,&icon);
  free(cx);
  free(cy);

  shape[0]=n-1;
  nc = ssl2_getary(c,1,shape);
  nd = ssl2_getary(d,1,shape);
  ne = ssl2_getary(e,1,shape);
  free(c);
  free(d);
  free(e);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(3,nc,nd,ne);
}


static VALUE
rb_bic1(self, x, y, dy, m)
     VALUE self, x, y, dy, m;
{
  float *cx;
  float *cy;
  float *cdy;
  int n;
  int cm;
  float *c;
  float *vw;
  int icon;

  VALUE nc;
  int *shape;

  int nn;

  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);

  if ( n<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 2");

  cy = ssl2_getcary(y,&nn);

  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be x.length");

  cdy = ssl2_getcary(dy,&nn);

  if ( nn!=(cm-1) )
    rb_raise(rb_eRuntimeError, "dy.length must be m-1");

  vw =  ALLOC_N(float,(n-1)*cm+(cm+1)*(cm+1)/2+(cm+1));
  c = ALLOC_N(float,n+cm-1);

  bic1_(cx,cy,cdy,&n,&cm,c,vw,&icon);
  free(vw);
  free(cx);
  free(cy);
  free(cdy);

  shape = ALLOC_N(int,1);
  shape[0] = n+cm-1;
  nc = ssl2_getary(c,1,shape);
  free(shape);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return nc;
}


static VALUE
rb_bic2(self, x, y, dy, m)
     VALUE self, x, y, dy, m;
{
  float *cx;
  float *cy;
  float *cdy;
  int n;
  int cm;
  float *c;
  float *vw;
  int icon;

  VALUE nc;
  int *shape;

  int nn;

  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);

  if ( n<(cm+1)/2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= (m+1)/2");

  cy = ssl2_getcary(y,&nn);

  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be x.length");

  cdy = ssl2_getcary(dy,&nn);

  if ( nn!=(cm-1) )
    rb_raise(rb_eRuntimeError, "dy.length must be m-1");

  vw = ALLOC_N(float,cm*(n+cm-3)+2*(cm+1));
  c = ALLOC_N(float,n+cm-1);

  bic2_(cx,cy,cdy,&n,&cm,c,vw,&icon);
  free(vw);
  free(cx);
  free(cy);
  free(cdy);

  shape = ALLOC_N(int,1);
  shape[0] = n+cm-1;
  nc = ssl2_getary(c,1,shape);
  free(shape);
  free(c);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return nc;
}


static VALUE
rb_bic3(self, x, y, m)
     VALUE self, x, y, m;
{
  float *cx;
  float *cy;
  int n;
  int cm;
  float *c;
  float *xt;
  float *vw;
  int icon;

  VALUE nc, nxt;
  int shape[1];

  int nn;

  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);
  if ( n<cm+2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= (m+1)/2");

  cy = ssl2_getcary(y,&nn);
  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be x.length");



  c = ALLOC_N(float,n);
  xt = ALLOC_N(float,n-cm+1);
  vw = ALLOC_N(float,cm*n+2);

  bic3_(cx,cy,&n,&cm,c,xt,vw,&icon);
  free(cx);
  free(cy);
  free(vw);

  shape[0] = n;
  nc = ssl2_getary(c,1,shape);
  free(c);
  shape[0] = n-cm+1;
  nxt = ssl2_getary(xt,1,shape);
  free(xt);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(2,nc,nxt);
}


static VALUE
rb_bic4(self, x, y, m)
     VALUE self, x, y, m;
{
  float *cx;
  float *cy;
  int n;
  int cm;
  float *c;
  float *vw;
  int icon;

  VALUE nc, nxt;
  int shape[1];

  int nn;

  cm = NUM2INT(m);
  if ( cm/2*2 == cm )
    rb_raise(rb_eRuntimeError, "m must be even");
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&n);
  if ( n<cm+2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= (m+1)/2");

  cy = ssl2_getcary(y,&nn);
  if ( nn!=n )
    rb_raise(rb_eRuntimeError, "y.length must be x.length");


  c = ALLOC_N(float,n+cm-1);
  vw = ALLOC_N(float,(n-1)*(2*cm-1)+cm+1);

  bic4_(cx,cy,&n,&cm,c,vw,&icon);
  free(cx);
  free(cy);
  free(vw);

  shape[0] = n+cm-1;
  nc = ssl2_getary(c,1,shape);
  free(c);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return nc;
}


static VALUE
rb_bicd1(self, x, y, fxy, m)
     VALUE self, x, y, fxy, m;
{
  float *cx;
  int nx;
  float *cy;
  int ny;
  float *cfxy;
  int k;
  int cm;
  float *c;
  float *vw;
  int icon;

  VALUE nc;
  int shape[2];

  int nn;

  cm = NUM2INT(m);
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  cx = ssl2_getcary(x,&nx);
  if ( nx<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 2");

  cy = ssl2_getcary(y,&ny);
  if ( ny<2 )
    rb_raise(rb_eRuntimeError, "y.length must be >= 2");

  cfxy = ssl2_getcary(fxy,&nn);
  k = nn/(ny+cm-1);
  if ( nn!=(nx+cm-1)*(ny+cm-1) )
    rb_raise(rb_eRuntimeError, "fxy.length must be (nx+m-1)*(ny+m-1)");


  c = ALLOC_N(float,(nx+cm-1)*(ny+cm-1));
  vw = ALLOC_N(float,(MAX(nx,ny)+1)*(cm*2)-3+(cm+1)*(cm+1)/2);
  bicd1_(cx,&nx,cy,&ny,cfxy,&k,&cm,c,vw,&icon);
  free(cx);
  free(cy);
  free(cfxy);
  free(vw);

  shape[0] = nx+cm-1;
  shape[1] = ny+cm-1;
  nc = ssl2_getary(c,2,shape);
  free(c);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return nc;
}


static VALUE
rb_bicd3(self, x, y, fxy, m)
     VALUE self, x, y, fxy, m;
{
  float *cx;
  int nx;
  float *cy;
  int ny;
  float *cfxy;
  int cm;
  float *c;
  float *xt;
  float *vw;
  int icon;

  VALUE nc, nxt;
  int *shape;

  int nn;

  cx = ssl2_getcary(x,&nx);
  if ( nx<2 )
    rb_raise(rb_eRuntimeError, "x.length must be >= 2");

  cy = ssl2_getcary(y,&ny);
  if ( ny<2 )
    rb_raise(rb_eRuntimeError, "y.length must be >= 2");

  cfxy = ssl2_getcary(fxy,&nn);
  if ( nn!=nx*ny )
    rb_raise(rb_eRuntimeError, "fxy.length must be nx*ny");

  cm = NUM2INT(m);
  if ( cm<3 )
    rb_raise(rb_eRuntimeError, "m must be >= 3");

  c = ALLOC_N(float,nx*ny);
  xt = ALLOC_N(float,(nx+cm-1)*(ny+cm-1));
  vw = ALLOC_N(float,(MAX(nx,ny)-2)*cm+2*(cm+1)+2*MAX(nx,ny));
  bicd3_(cx,&nx,cy,&ny,cfxy,&nx,&cm,c,xt,vw,&icon);
  free(cx);
  free(cy);
  free(cfxy);
  free(vw);

  shape = ALLOC_N(int,2);
  shape[0] = nx;
  shape[1] = ny;
  nc = ssl2_getary(c,2,shape);
  free(c);
  free(shape);
  shape = ALLOC_N(int,1);
  shape[0]=(nx+cm-1)*(ny+cm-1);
  nxt = ssl2_getary(xt,1,shape);
  free(xt);
  free(shape);

  if ( icon!=0 )
    fprintf(stderr,"icon is %d\n",icon);
  return rb_ary_new3(2,nc,nxt);
}


void init_interpolation(mSSL2)
     VALUE mSSL2;
{
  rb_define_module_function(mSSL2, "aklag", rb_aklag, 5);
  rb_define_module_function(mSSL2, "akher", rb_akher, 6);
  rb_define_module_function(mSSL2, "splv", rb_splv, 5);
  rb_define_module_function(mSSL2, "bif1", rb_bif1, 5);
  rb_define_module_function(mSSL2, "bif2", rb_bif2, 5);
  rb_define_module_function(mSSL2, "bif3", rb_bif3, 6);
  rb_define_module_function(mSSL2, "bif4", rb_bif4, 5);
  rb_define_module_function(mSSL2, "bifd1", rb_bifd1, 8);
  rb_define_module_function(mSSL2, "bifd3", rb_bifd3, 9);
  rb_define_module_function(mSSL2, "akmid", rb_akmid, 7);
  rb_define_module_function(mSSL2, "inspl", rb_inspl, 3);
  rb_define_module_function(mSSL2, "akmin", rb_akmin, 2);
  rb_define_module_function(mSSL2, "bic1", rb_bic1, 4);
  rb_define_module_function(mSSL2, "bic2", rb_bic2, 4);
  rb_define_module_function(mSSL2, "bic3", rb_bic3, 3);
  rb_define_module_function(mSSL2, "bic4", rb_bic4, 3);
  rb_define_module_function(mSSL2, "bicd1", rb_bicd1, 4);
  rb_define_module_function(mSSL2, "bicd3", rb_bicd3, 4);
}
